import { LRParser } from '@lezer/lr';
import { LRLanguage, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "#lQVQPOOO_QPO'#C^OOQO'#Ck'#CkOOQO'#Cg'#CgQVQPOOOdQQO,58xOOQO-E6e-E6eOiQPO'#CbOnQPO'#CaOsQPO1G.dOxQQO,58|OdQQO,58{O}QPO7+$OO!SQPO1G.hOOQO1G.g1G.gOOQO<<Gj<<GjO!XQQO7+$SO!^QPO<<GnO!cQSOAN=YOOQOG22tG22t",
  stateData: "!h~O^OS~ORPOSQO~OSTO~OVVO~O`YO~OXZO~OS[O~OV]O~OY_O~O``O~OVaO~OabO~OWcO~O",
  goto: "x`PPaPPehPPPPnPPPtTQOSRXTQWTR^ZQSORUSTROS",
  nodeNames: "⚠ SubtitleFile Subtitle SubtitleIndex NewLine TimeRange Time TwoDigitTime ThreeDigitTime TimeSeparator SubtitleText",
  maxTerm: 17,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "$e~RYXYqYZ|]^|pqq|}!R}!O!W!Q![!i![!]#_!c!}#d#T#o#d~vQ^~XYqpqq~!ROS~~!WOa~~!ZP}!O!^~!aP!`!a!d~!iOX~V!nPRP!Q![!qV!xPRPVQ!Q![!{T#SPRPWS!Q![#VP#[PRP!Q![#V~#dO`~~#iUY~XY#{YZ$[]^$[pq#{!c!}#d#T#o#d~$OSXY#{pq#{!c!}#d#T#o#d~$_Q!c!}#d#T#o#d",
  tokenizers: [0, 1, 2],
  topRules: {"SubtitleFile":[0,1]},
  tokenPrec: 0
});

const SrtLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            foldNodeProp.add({
                Subtitle: foldInside
            }),
            styleTags({
                SubtitleIndex: tags.variableName,
                TwoDigitTime: tags.number,
                ThreeDigitTime: tags.number,
                TimeSeparator: tags.punctuation,
                SubtitleText: tags.constant(tags.string),
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function Srt() {
    return new LanguageSupport(SrtLanguage);
}

export { Srt, SrtLanguage };
